package org.joget.hyperledger;

import java.util.HashMap;
import java.util.Map;
import org.joget.plugin.base.PluginManager;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath:testApplicationContext.xml"})
public class TestFabric {

    @Autowired 
    PluginManager pluginManager;

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test tool to query and update the blockchain.
     */
    @Test
    public void testFabricTool() {
        String pluginFile = "target/joget-hyperledger-fabric.jar";
        String pluginName = "org.joget.hyperledger.FabricTool";
        
        /*-- Test fabcar chaincode functions
        // query all cars
        String functionName = "queryAllCars";
        String[] functionArgs = null;

        // create car
        String functionName = "createCar";
        String[] functionArgs = new String[]{"CAR12", "Honda", "Civic", "White", "Lenny"};

        // query single car
        String functionName = "queryCar";
        String[] functionArgs = new String[]{"CAR12"};        
        --*/

        // set plugin properties
        Map pluginProps = new HashMap();
        pluginProps.put("pluginManager", pluginManager);
        pluginProps.put("userId", "hfuser");
        pluginProps.put("affiliation", "org1");
        pluginProps.put("mspId", "Org1MSP");
        pluginProps.put("registerNewUser", "true");
        pluginProps.put("userCert", "-----BEGIN CERTIFICATE-----\\nMIICcDCCAhegAwIBAgIUECFWHr+mI+mbs0VxfE1/obYKkmkwCgYIKoZIzj0EAwIw\\nczELMAkGA1UEBhMCVVMxEzARBgNVBAgTCkNhbGlmb3JuaWExFjAUBgNVBAcTDVNh\\nbiBGcmFuY2lzY28xGTAXBgNVBAoTEG9yZzEuZXhhbXBsZS5jb20xHDAaBgNVBAMT\\nE2NhLm9yZzEuZXhhbXBsZS5jb20wHhcNMjAwMjI4MDkzMzAwWhcNMjEwMjI3MDkz\\nODAwWjAvMRwwDQYDVQQLEwZjbGllbnQwCwYDVQQLEwRvcmcxMQ8wDQYDVQQDEwZo\\nZnVzZXIwWTATBgcqhkjOPQIBBggqhkjOPQMBBwNCAAR3QvywZLnRtiI1AaxOieFa\\nduck4Wrx7NGXcrLj3RXeWphMip7ntMYUVokC5RIGXKkgYtnTB+PoJt1vpqF6ig7h\\no4HMMIHJMA4GA1UdDwEB/wQEAwIHgDAMBgNVHRMBAf8EAjAAMB0GA1UdDgQWBBTU\\nWcJISxwlAw/2bTKLgqZSlNQArDArBgNVHSMEJDAigCAfQ/gEM+ExDpoiA/ap/PgJ\\n7cOYbmgDhUQVU5NSlE4POjBdBggqAwQFBgcIAQRReyJhdHRycyI6eyJoZi5BZmZp\\nbGlhdGlvbiI6Im9yZzEiLCJoZi5FbnJvbGxtZW50SUQiOiJoZnVzZXIiLCJoZi5U\\neXBlIjoiY2xpZW50In19MAoGCCqGSM49BAMCA0cAMEQCIFNgmT2Cs2oEkCxMGSWQ\\nn8z+cdCNZcrD477Hh8KkNnxIAiBl8iVRAEM/C7HdbHDqf50qEfUDdwc2pW/vxSps\\nEKw1jw\\u003d\\u003d\\n-----END CERTIFICATE-----\\n");
        pluginProps.put("userPrivateKey", "-----BEGIN EC PRIVATE KEY-----\nMHcCAQEEIHKreHfNagp368HIOGJx0Pwq02ALbAm34GEMXLfyQpN3oAoGCCqGSM49\nAwEHoUQDQgAEd0L8sGS50bYiNQGsTonhWnbnJOFq8ezRl3Ky490V3lqYTIqe57TG\nFFaJAuUSBlypIGLZ0wfj6Cbdb6aheooO4Q==\n-----END EC PRIVATE KEY-----");
        pluginProps.put("adminId", "admin");
        pluginProps.put("adminSecret", "adminpw");
        pluginProps.put("connectionProfileJson", "{\n" +
            "    \"name\": \"mychannel\",\n" +
            "    \"version\": \"1.0.0\",\n" +
            "    \"client\": {\n" +
            "        \"organization\": \"org1\",\n" +
            "        \"connection\": {\n" +
            "            \"timeout\": {\n" +
            "                \"peer\": {\n" +
            "                    \"endorser\": \"300\"\n" +
            "                }\n" +
            "            }\n" +
            "        }\n" +
            "    },\n" +
            "    \"organizations\": {\n" +
            "        \"Org1\": {\n" +
            "            \"mspid\": \"Org1MSP\",\n" +
            "            \"peers\": [\n" +
            "                \"peer0.org1.example.com\",\n" +
            "                \"peer1.org1.example.com\"\n" +
            "            ],\n" +
            "            \"certificateAuthorities\": [\n" +
            "                \"ca.org1.example.com\"\n" +
            "            ]\n" +
            "        }\n" +
            "    },\n" +
            "    \"peers\": {\n" +
            "        \"peer0.org1.example.com\": {\n" +
            "            \"url\": \"grpcs://peer0.org1.example.com:7051\",\n" +
            "            \"tlsCACerts\": {\n" +
            "                \"pem\": \"-----BEGIN CERTIFICATE-----\\nMIICVjCCAf2gAwIBAgIQXD6OBR2vuVZkd7BE8TvqVzAKBggqhkjOPQQDAjB2MQsw\\nCQYDVQQGEwJVUzETMBEGA1UECBMKQ2FsaWZvcm5pYTEWMBQGA1UEBxMNU2FuIEZy\\nYW5jaXNjbzEZMBcGA1UEChMQb3JnMS5leGFtcGxlLmNvbTEfMB0GA1UEAxMWdGxz\\nY2Eub3JnMS5leGFtcGxlLmNvbTAeFw0yMDAyMjgwNjA5MDBaFw0zMDAyMjUwNjA5\\nMDBaMHYxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlhMRYwFAYDVQQH\\nEw1TYW4gRnJhbmNpc2NvMRkwFwYDVQQKExBvcmcxLmV4YW1wbGUuY29tMR8wHQYD\\nVQQDExZ0bHNjYS5vcmcxLmV4YW1wbGUuY29tMFkwEwYHKoZIzj0CAQYIKoZIzj0D\\nAQcDQgAEReyfwfpBpEeHrmMecKVbtVfknG279KOv3Hi6jqCRGh9ZyfE/NrOH7jf8\\n+PPVb44AmtVsmMxP2AJ8ShAoiYhvJKNtMGswDgYDVR0PAQH/BAQDAgGmMB0GA1Ud\\nJQQWMBQGCCsGAQUFBwMCBggrBgEFBQcDATAPBgNVHRMBAf8EBTADAQH/MCkGA1Ud\\nDgQiBCACaBlBzVBkLpzksp7VtRnSpaIPzVLJ+0hJSXcDMIsv2DAKBggqhkjOPQQD\\nAgNHADBEAiBpRziBCzJTLa3fUp9M+KS5iHI6mk9Vs6eLX3K2YmKNxQIgCdm4AVpj\\nExUbfxSr5PTA+8O1ZjIB7n8jT4fQKbZTHtw=\\n-----END CERTIFICATE-----\\n\"\n" +
            "            },\n" +
            "            \"grpcOptions\": {\n" +
            "                \"ssl-target-name-override\": \"peer0.org1.example.com\",\n" +
            "                \"hostnameOverride\": \"peer0.org1.example.com\"\n" +
            "            }\n" +
            "        },\n" +
            "        \"peer1.org1.example.com\": {\n" +
            "            \"url\": \"grpcs://peer1.org1.example.com:8051\",\n" +
            "            \"tlsCACerts\": {\n" +
            "                \"pem\": \"-----BEGIN CERTIFICATE-----\\nMIICVjCCAf2gAwIBAgIQXD6OBR2vuVZkd7BE8TvqVzAKBggqhkjOPQQDAjB2MQsw\\nCQYDVQQGEwJVUzETMBEGA1UECBMKQ2FsaWZvcm5pYTEWMBQGA1UEBxMNU2FuIEZy\\nYW5jaXNjbzEZMBcGA1UEChMQb3JnMS5leGFtcGxlLmNvbTEfMB0GA1UEAxMWdGxz\\nY2Eub3JnMS5leGFtcGxlLmNvbTAeFw0yMDAyMjgwNjA5MDBaFw0zMDAyMjUwNjA5\\nMDBaMHYxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlhMRYwFAYDVQQH\\nEw1TYW4gRnJhbmNpc2NvMRkwFwYDVQQKExBvcmcxLmV4YW1wbGUuY29tMR8wHQYD\\nVQQDExZ0bHNjYS5vcmcxLmV4YW1wbGUuY29tMFkwEwYHKoZIzj0CAQYIKoZIzj0D\\nAQcDQgAEReyfwfpBpEeHrmMecKVbtVfknG279KOv3Hi6jqCRGh9ZyfE/NrOH7jf8\\n+PPVb44AmtVsmMxP2AJ8ShAoiYhvJKNtMGswDgYDVR0PAQH/BAQDAgGmMB0GA1Ud\\nJQQWMBQGCCsGAQUFBwMCBggrBgEFBQcDATAPBgNVHRMBAf8EBTADAQH/MCkGA1Ud\\nDgQiBCACaBlBzVBkLpzksp7VtRnSpaIPzVLJ+0hJSXcDMIsv2DAKBggqhkjOPQQD\\nAgNHADBEAiBpRziBCzJTLa3fUp9M+KS5iHI6mk9Vs6eLX3K2YmKNxQIgCdm4AVpj\\nExUbfxSr5PTA+8O1ZjIB7n8jT4fQKbZTHtw=\\n-----END CERTIFICATE-----\\n\"\n" +
            "            },\n" +
            "            \"grpcOptions\": {\n" +
            "                \"ssl-target-name-override\": \"peer1.org1.example.com\",\n" +
            "                \"hostnameOverride\": \"peer1.org1.example.com\"\n" +
            "            }\n" +
            "        }\n" +
            "    },\n" +
            "    \"certificateAuthorities\": {\n" +
            "        \"ca.org1.example.com\": {\n" +
            "            \"url\": \"https://ca.org1.example.com:7054\",\n" +
            "            \"caName\": \"ca-org1\",\n" +
            "            \"tlsCACerts\": {\n" +
            "                \"pem\": \"-----BEGIN CERTIFICATE-----\\nMIICUjCCAfegAwIBAgIQCrwlo3Hpdt2jdyW6qrKIbTAKBggqhkjOPQQDAjBzMQsw\\nCQYDVQQGEwJVUzETMBEGA1UECBMKQ2FsaWZvcm5pYTEWMBQGA1UEBxMNU2FuIEZy\\nYW5jaXNjbzEZMBcGA1UEChMQb3JnMS5leGFtcGxlLmNvbTEcMBoGA1UEAxMTY2Eu\\nb3JnMS5leGFtcGxlLmNvbTAeFw0yMDAyMjgwNjA5MDBaFw0zMDAyMjUwNjA5MDBa\\nMHMxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlhMRYwFAYDVQQHEw1T\\nYW4gRnJhbmNpc2NvMRkwFwYDVQQKExBvcmcxLmV4YW1wbGUuY29tMRwwGgYDVQQD\\nExNjYS5vcmcxLmV4YW1wbGUuY29tMFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAE\\npHOkDi8MC9nSHw1DjJw/Hp2VtyuM76V+4jKIF+YM7Q/D3aEBJfpnhYey5VDn6EwF\\ni4p+BaqYMhHqfwpsh5ffBaNtMGswDgYDVR0PAQH/BAQDAgGmMB0GA1UdJQQWMBQG\\nCCsGAQUFBwMCBggrBgEFBQcDATAPBgNVHRMBAf8EBTADAQH/MCkGA1UdDgQiBCAf\\nQ/gEM+ExDpoiA/ap/PgJ7cOYbmgDhUQVU5NSlE4POjAKBggqhkjOPQQDAgNJADBG\\nAiEAv0DiZuLLnJnS1lNASWO0IJI65+sCmP+NkUVDawVmBdUCIQDa5SUpby0leKP3\\nrKTrT+qLjDy/08e0yq80K0y1JJLqNw==\\n-----END CERTIFICATE-----\\n\"\n" +
            "            },\n" +
            "            \"httpOptions\": {\n" +
            "                \"verify\": false\n" +
            "            }\n" +
            "        }\n" +
            "    },\n" +
            "    \"orderers\": {\n" +
            "        \"orderer.example.com\": {\n" +
            "            \"url\": \"grpcs://orderer.example.com:7050\",\n" +
            "            \"tlsCACerts\": {\n" +
            "                \"pem\": \"-----BEGIN CERTIFICATE-----\\nMIICRTCCAeqgAwIBAgIRANFAl69K7Mrf4+1AjZmQDkUwCgYIKoZIzj0EAwIwbDEL\\nMAkGA1UEBhMCVVMxEzARBgNVBAgTCkNhbGlmb3JuaWExFjAUBgNVBAcTDVNhbiBG\\ncmFuY2lzY28xFDASBgNVBAoTC2V4YW1wbGUuY29tMRowGAYDVQQDExF0bHNjYS5l\\neGFtcGxlLmNvbTAeFw0yMDAyMjgwNjA5MDBaFw0zMDAyMjUwNjA5MDBaMGwxCzAJ\\nBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlhMRYwFAYDVQQHEw1TYW4gRnJh\\nbmNpc2NvMRQwEgYDVQQKEwtleGFtcGxlLmNvbTEaMBgGA1UEAxMRdGxzY2EuZXhh\\nbXBsZS5jb20wWTATBgcqhkjOPQIBBggqhkjOPQMBBwNCAATWf0pi7fWKRIjC8E0j\\nH5TPigRjaH84u9Ab+6xffEb7ssvqnPaflMjnkH7UGoBbb+TFrzZG5e62VspLpLVQ\\n9z0Wo20wazAOBgNVHQ8BAf8EBAMCAaYwHQYDVR0lBBYwFAYIKwYBBQUHAwIGCCsG\\nAQUFBwMBMA8GA1UdEwEB/wQFMAMBAf8wKQYDVR0OBCIEIPyXanFloSdl5SSV266H\\nnGCi1V7jismRbjqieAhDT+mVMAoGCCqGSM49BAMCA0kAMEYCIQDnzWW+FS5pM+70\\n6V0+gzhY2rT9eTYZjvPuxkDQLq8VrwIhANoQ4WJCUpA9cHN8mVS0ZCwjELRY+3rH\\n1A//DElMoZ3i\\n-----END CERTIFICATE-----\"\n" +
            "            },\n" +
            "            \"grpcOptions\": {\n" +
            "                \"ssl-target-name-override\": \"orderer.example.com\",\n" +
            "                \"hostnameOverride\": \"orderer.example.com\"\n" +
            "            }\n" +
            "        }\n" +
            "    }\n" +
            "}");
        pluginProps.put("transactionType", "query");
        pluginProps.put("chaincodeId", "fabcar");
        pluginProps.put("functionName", "queryAllCars");
        pluginProps.put("functionArgs", new String[]{"CAR12", "Honda", "Civic", "White", "Lenny"});        
        pluginProps.put("debugMode", "true");

        // execute plugin
        Boolean status = (Boolean)pluginManager.testPlugin(pluginName, pluginFile, pluginProps, true);
        Assert.assertTrue(status);
    }    
    
}
